%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright (c) 2023, Amon Lahr, Simon Muntwiler, Antoine Leeman & Fabian Flürenbrock Institute for Dynamic Systems and Control, ETH Zurich.
%
% All rights reserved.
%
% Please see the LICENSE file that has been included as part of this package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

classdef LQR
    properties
        K
    end
    
    methods
        %constructor
        function obj = LQR(Q,R,params)
            % YOUR CODE HERE
            E = zeros(params.model.nx);
            S = zeros(params.model.nx, params.model.nu);
            Pinf = idare(params.model.A, params.model.B, Q, R);
            obj.K = -inv(R + params.model.B' * Pinf * params.model.B) ...
                * params.model.B' * Pinf * params.model.A;
        end
        
        function [u, ctrl_info] = eval(obj,x)
            % YOUR CODE HERE
            u = obj.K * x;
            ctrl_info = struct('ctrl_feas',true);
        end
    end
end
